/*
 * @(#)DefaultElement.java
 *
 * Copyright 2001 by Intelligent Technology Inc. All rights reserved.
 */
package jp.co.iti.fagot.doc;

import org.w3c.dom.DOMException;

import jp.co.iti.fagot.geom.ZRectangle;

import jp.co.iti.fagot.gob.GElement;
import jp.co.iti.fagot.gob.GOperation;

import jp.co.iti.fagot.util.ZDebug;
/**
 * エレメント
 *
 * Gobコンテナとして必要最低限の定義を実装するクラス
 * デフォルト動作として、背景が白の矩形を描画する
 *
 * @author  福島康治
 * @version 1.01 2001/03/22
 */
public class DefaultElement extends DocElement implements IElement {

	/**
	 * デフォルトコンストラクタ
	 */
	protected DefaultElement() throws DOMException {
	}

	//## IGobContainer：移動 ##########################################
	/**
	 * 移動の完了
	 * @param gob  リクエスト元Gob
	 * @param grid グリッドコントローラ
	 */
	public void moveEnd(GElement gob,DocGridControler grid) {
	ZRectangle rect = new ZRectangle(getMovingPath(gob,grid).getBounds2D());
	DocPane editor = grid.getEditor();

	switch ( grid.getMoveMode() ) {
	  case GOperation.NEW:		// 新規作成
		// 追加
		setSelect(null,true);
		DocDocument doc = editor.getDocument();
		setDocument( doc );
		doc.getRootElement(editor.getPanelId()).appendChild(this);
		break;

	  default:	// その他移動
		// 移動しなかった場合はmoveEndはcallされないので必ず選択状態になる
		break;
	}

	setRect( editor.getPanelId(),rect ) ;
//	editor.updateGobs();
	}

	//## アトリビュート################################################
}
